#include <avr/io.h>
#include "config.h"




.global wait1000ms
.func wait1000ms
.global wait500ms
.global wait300ms
.global wait200ms
.global wait100ms
.global wait50ms
.global wait30ms
.global wait20ms
.global wait10ms
.global wait5ms
.global wait3ms
.global wait2ms
.global wait1ms
.global wait500us
.global wait300us
.global wait200us
.global wait100us
.global wait50us
.global wait30us
.global wait20us
.global wait10us

;WarteSchleifen fuer ATmega8 bei 1MHz
; Es werden 60 Byte Programmspeicher (30 Befehle) inklusive Watch Dog reset bei wait100ms belegt
; und keine Register benutzt.
; Routinen brauchen maximal 22 Byte Stack (RAM) für return-Adressen
; Jeder Aufruf braucht nur einen Befehl (rcall).
;                               Punkte stehen für Stack-Pointer return Addressen

wait1000ms:	
 rcall wait500ms	;500ms	..... ..... .
;laueft in wait500ms	;1s	..... .....  

wait500ms:
 rcall wait100ms	;100ms	..... .....
 rcall wait100ms	;200ms	..... .....

wait300ms:
 rcall wait100ms        ;300ms	..... ..... 
; laeuft in wait200ms	;500ms	..... .....


wait200ms:
 rcall wait100ms	;100ms	..... ..... 
; laeuft in wait100ms 	;200ms	..... ....


wait100ms:
 wdr				// alle 100ms ein Watchdog reset!
 rcall wait50ms	    	; 50ms	..... ....
;laeuft in wait50us 	;100ms	..... ...

wait50ms:
 rcall wait10ms	    	;10ms	..... ... 
 rcall wait10ms	    	;20ms	..... ...  
;laeuft in wait30us 	;50ms	..... ...

wait30ms:
 rcall wait10ms	    	;10ms	..... ... 
;laeuft in wait20us 	;30ms	..... ...

wait20ms:
 rcall wait10ms	    	;10ms	..... ...
; laeuft in wait10ms	;20ms	..... ..

wait10ms:
 rcall wait5ms	   	;5ms	..... ..
; laueft in wait5ms	;10ms	..... .

wait5ms:
 rcall wait1ms	   	;1ms	..... .
 rcall wait1ms	   	;2ms	..... .
; laueft in wait3ms	;5ms	..... .

wait3ms:
 rcall wait1ms	   	;1ms	..... .
; laeuft in wait2ms	;3ms	..... .


wait2ms:
 rcall wait1ms	   	;1ms	..... .
; laeuft in wait1ms	;2ms	.....

wait1ms:
 rcall wait500us    	;500us	..... 
;laeuft in wait500us	;1ms	....

wait500us:
 rcall wait100us    	;100us	....
 rcall wait100us    	;200us	.... 
;laeuft in wait300us	;500us	....

wait300us:
 rcall wait100us    	;100us	.... 
;laeuft in wait200us	;300us	....

wait200us:
 rcall wait100us    	;100us	....
; laeuft in wait100us	;200us	...


wait100us:
 rcall wait50us	    	; 50us	...
; laeuft in wait50us	;100us	..

wait50us:
 rcall wait10us     	;10us	..
 rcall wait10us     	;20us	..
; laeuft in wait30us	;50us	.

wait30us:
 rcall wait10us     	;10us	..
; laeuft in wait20us	;20us	.

wait20us:
 rcall wait10us		;10us	..
; laeuft weiter in wait10us	.


wait10us:		;	.
; rcall bei ATmega8L 4 Zyklen
 nop
 nop
 nop   ;bei ATmega8 (ohne L) braucht rcall nur 3 Zyklen
; ret braucht 4 Zyklen (je 1 µs)
 ret


